import es
import cfglib

info = es.AddonInfo()
info.name = 'AutoGunGame'
info.version  = '1.14'
info.author = 'scaiyth'
info.url = 'http://addons.eventscripts.com/addons/view/autogungame'
info.description = "Auto loads GunGame on GG maps & more"
info.basename = 'autogungame'

es.ServerVar('AutoGunGame', info.version, info.name + ': ' + info.description + '\n// by ' + info.author).makepublic()

aggconfig = cfglib.AddonCFG(es.getAddonPath(info.basename) + "/config.cfg", 1)
gg_maps = aggconfig.cvar('agg_maps', 'gg_', 'Mapnames or parts of mapnames (e.g. prefixes) which trigger the script to load GunGame')
gg_except_maps = aggconfig.cvar('agg_except_maps', '', 'Mapnames which AutoGunGame will ignore for loading')
gungame_version = aggconfig.cvar('agg_load_version', 'gungame', 'GunGame version (script name) that will be loaded')
auto_unload_gg = aggconfig.cvar('agg_auto_unload', 1, 'Enable/Disable unloading GunGame on non-GG maps')
auto_disable_ar = aggconfig.cvar('agg_disable_ar', 0, 'Disable mani_anti_rejoin during GunGame')
auto_disable_ar_ggmaps_only = aggconfig.cvar('agg_disable_ar_ggmaps_only', 1, 'Disable mani_anti_rejoin during GunGame (->on GG maps only)\n=> agg_disable_ar must be set to 1 first')

agg_spawnpointfix = 0

def load():
	aggconfig.execute()

def es_map_start(event_var):
	global agg_spawnpointfix
	gg_loaded = gg_loaded_check()
	if not gg_loaded and gg_map_check(event_var['mapname']) == 1:
		es.delayed('1', 'es_load %s' % gungame_version)
	elif gg_loaded:
		if auto_unload_gg == 1 and gg_map_check(event_var['mapname']) == 0:
			es.unload(gungame_version)
			if str(es.ServerVar('eventscripts_gg')) < "5.1": es.delayed('2', 'exec server.cfg')
		elif agg_spawnpointfix:
			es.ServerVar('gg_spawnpoints').set(1)
			agg_spawnpointfix = 0

def round_start(event_var):
	if auto_disable_ar == 1 and es.ServerVar('mani_anti_rejoin') != 0 and gg_loaded_check() == 1:
		if auto_disable_ar_ggmaps_only == 1 and gg_map_check() == 1 or auto_disable_ar_ggmaps_only == 0:
			es.ServerVar('mani_anti_rejoin').set(0)

def gg_win(event_var):
	global agg_spawnpointfix
	spawnpoints = es.ServerVar('gg_spawnpoints')
	if spawnpoints == 1 and event_var['round'] == '0' and '5.0.' in str(es.ServerVar('eventscripts_gg')) and gg_map_check(es.ServerVar('eventscripts_nextmapoverride')) == 0: 
		spawnpoints.set(0)
		agg_spawnpointfix = 1

def gg_loaded_check():
	if gungame_version != 'gungame':
		if es.exists('script', gungame_version):
			return 1
	else:
		for gungame5 in es.addons.getAddonList():
			gg5string = str(gungame5.__name__)
			if gg5string == gungame_version + '.' + gungame_version:
				return 1
		else:
			return 0

def gg_map_check(map = es.ServerVar('eventscripts_currentmap')):
	map = str(map).lower()
	if map != "":
		for gg_except_map in str(gg_except_maps).replace(" ", "").split(","):
			if gg_except_map.lower() == map:
				return 0
		else:
			for mapstring in str(gg_maps).replace(" ", "").split(","):
				if mapstring.lower() in map and mapstring != "":
					return 1
			else:
				return 0
	else:
		return 0